SystemOrganization addCategory: #'SOUL-Mantis'!

Object subclass: #SoulMantisImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Mantis'!

SoulMantisImporter subclass: #SoulMantisImporterCSV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Mantis'!

!SoulMantisImporterCSV methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:46'!
createProjectWithName: aString
	| project |
	project  := SoulMantisProject new.
	project 
		name: aString;
		description: aString.
	^project
	! !

!SoulMantisImporterCSV methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:46'!
fileStreamOn: aString
	^FileStream fileNamed: aString.! !

!SoulMantisImporterCSV methodsFor: 'importing' stamp: 'AndyKellens 3/12/2012 15:37'!
importFromFileNamed: aString forProjectNamed: aProjectName
	| stream project |
	stream := self fileStreamOn: aString.
	project := self createProjectWithName: aProjectName.
	self importIssues: stream forProject: project.
	SoulMantisRepository current addProject: project! !

!SoulMantisImporterCSV methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:48'!
importIssues: aStream forProject: aProject
	self skipHeaderOfCSVFile: aStream.
	[aStream atEnd]
		whileFalse:[
			| line issue |
			line := aStream upTo: (Character cr).
			issue := SoulMantisIssue fromCSVLine: (ReadStream on: line).
			aProject addIssue: issue]! !

!SoulMantisImporterCSV methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:47'!
skipHeaderOfCSVFile: aStream
	aStream skipTo: (Character cr)! !

Object subclass: #SoulMantisIssue
	instanceVariableNames: 'project status number summary description versionReported versionResolved category priority severity whenSubmitted whenLastChanged resolution reporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Mantis'!

!SoulMantisIssue class methodsFor: 'instance creation' stamp: 'AndyKellens 3/12/2012 13:34'!
fromCSVLine: aStream
	^self new fromCSVLine: aStream! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
category 
	^category! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:25'!
description
	^description! !

!SoulMantisIssue methodsFor: 'initialize-release' stamp: 'AndyKellens 3/12/2012 14:56'!
fromCSVLine: aStream
	number := self readNumberFrom: aStream.
	self skipProject: aStream.
	reporter := self readReporterFrom: aStream.
	self skipAssignedTo: aStream.
	priority := self readPriorityFrom: aStream.
	severity := self readSeverityFrom: aStream.
	self skipReproducibility: aStream.
	versionReported := self readProductVersionFrom: aStream.
	category := self readCategoryFrom: aStream.
	whenSubmitted := self readDateSubmittedFrom: aStream.
	self skipOS: aStream.
	self skipOSVersion: aStream.
	self skipPlatform: aStream.
	self skipViewStatus: aStream.
	whenLastChanged := self readUpdatedFrom: aStream.
	summary := self readSummaryFrom: aStream.
	status := self readStatusFrom: aStream.
	resolution := self readResolutionFrom: aStream.
	
	
	
	
	
	! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:25'!
number
	^number! !

!SoulMantisIssue methodsFor: 'printing' stamp: 'AndyKellens 3/12/2012 17:16'!
printOn: aStream
	aStream nextPutAll: 'Mantis issue ', number asString.
	aStream nextPut:$(.
	aStream nextPutAll: summary.
	aStream nextPut:$)! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
priority
	^priority! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:55'!
project
	^project! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:56'!
project: anObject
	project := anObject! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:56'!
readCategoryFrom: aStream
	^self readTokenFrom: aStream! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:56'!
readDateSubmittedFrom: aStream
	| token |
	token := self readTokenFrom: aStream.
	^Date fromString: token! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 15:01'!
readNumberFrom: aStream
	| token |
	aStream skipTo:$0.
	token := self readTokenFrom: aStream.
	^token asNumber! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 15:41'!
readPriorityFrom: aStream
	^(self readTokenFrom: aStream) asSymbol! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:56'!
readProductVersionFrom: aStream
	^self readTokenFrom: aStream! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:55'!
readReporterFrom: aStream
	^self readTokenFrom: aStream! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 15:41'!
readResolutionFrom: aStream
	^(self readTokenFrom: aStream) asSymbol! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 15:41'!
readSeverityFrom: aStream
	^(self readTokenFrom: aStream) asSymbol! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 15:40'!
readStatusFrom: aStream
	^(self readTokenFrom: aStream) asSymbol! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:58'!
readSummaryFrom: aStream
	^self readTokenFrom: aStream! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 15:04'!
readTokenFrom: aStream
	^(aStream peek = $")
		ifTrue:[
			| token |
			token := aStream upTo:$".
			aStream next.
			token]
		ifFalse:[aStream upTo:$,]! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:58'!
readUpdatedFrom: aStream
	| token |
	token := self readTokenFrom: aStream.
	^[Date fromString: token] on: Error do:[:exc| nil]! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:37'!
reporter
	^reporter! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
resolution
	^resolution! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
severity 
	^severity! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:55'!
skipAssignedTo: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:57'!
skipOS: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:57'!
skipOSVersion: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:57'!
skipPlatform: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:55'!
skipProject: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:56'!
skipReproducibility: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 13:44'!
skipTokenOn: aStream
	aStream skipTo: $,! !

!SoulMantisIssue methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 14:57'!
skipViewStatus: aStream
	self skipTokenOn: aStream.! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:25'!
status
	^status! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:25'!
summary 
	^summary! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
versionReported
	^versionReported ! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
versionResolved
	^versionResolved! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
whenLastChanged
	^whenLastChanged! !

!SoulMantisIssue methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:26'!
whenSubmitted
	^whenSubmitted! !

Object subclass: #SoulMantisProject
	instanceVariableNames: 'name description issues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Mantis'!

!SoulMantisProject methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 14:44'!
addIssue: anIssue
	anIssue project: self.
	issues add: anIssue! !

!SoulMantisProject methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 14:29'!
description
	^description
		! !

!SoulMantisProject methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 14:29'!
description: anObject
	description := anObject
		! !

!SoulMantisProject methodsFor: 'initialize-release' stamp: 'AndyKellens 3/12/2012 14:29'!
initialize
	super initialize.
	issues := OrderedCollection new! !

!SoulMantisProject methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 17:12'!
issues
	^issues! !

!SoulMantisProject methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 14:29'!
name
	^name! !

!SoulMantisProject methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 14:29'!
name: anObject
	name := anObject! !

!SoulMantisProject methodsFor: 'printing' stamp: 'AndyKellens 3/12/2012 17:07'!
printOn: aStream
	aStream nextPutAll: name! !

Object subclass: #SoulMantisRepository
	instanceVariableNames: 'projects'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'SOUL-Mantis'!

!SoulMantisRepository class methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:54'!
current 
	Current ifNil:[Current := self new].
	^Current! !

!SoulMantisRepository methodsFor: 'adding' stamp: 'AndyKellens 3/12/2012 14:51'!
addProject: aProject
	projects at: (aProject name) put: aProject! !

!SoulMantisRepository methodsFor: 'initialize-release' stamp: 'AndyKellens 3/12/2012 13:57'!
initialize
	super initialize.
	projects := Dictionary new! !

!SoulMantisRepository methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:57'!
projectWithName: aString
	^projects at: aString ifAbsent:[nil]! !

!SoulMantisRepository methodsFor: 'accessing' stamp: 'AndyKellens 3/12/2012 13:57'!
projects
	^projects values! !

LogicStorage subclass: #MantisLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Mantis'!

!MantisLayer class methodsFor: 'private' stamp: 'AndyKellens 3/12/2012 17:04'!
createMantisRepository 
	| rep |
	rep := SoulFactory current makeRepository new.
	rep loadLayer: MantisLayer.
	LogicPrimitives allSubclasses do: [:cl | rep loadLayer: cl].
	SoulFactory repository: #'Mantis' put: rep! !

!MantisLayer class methodsFor: 'initialize-release' stamp: 'AndyKellens 3/12/2012 17:03'!
initialize 
	self createMantisRepository! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:24'!
isIssueInCategoryXM2

?issue isIssueInCategory: ?category if 
	?issue isIssue,?category equals: [?issue category]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:12'!
isIssueInProjectXM2

?issue isIssueInProject: ?project if 
	?project isProject,[?project issues] contains: ?issue! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:26'!
isIssueLastChangedOnXM2

?issue isIssueLastChangedOn: ?date if 
	?issue isIssue,?date equals: [?issue whenLastChanged],[?date notNil]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:11'!
isIssueM1

+?issue isIssue if 
	[?issue isKindOf: SoulMantisIssue].

-?issue isIssue if 
	?project isProject,?issue isIssueInProject: ?project! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:29'!
isIssueReportedByXM2

?issue isIssueReportedBy: ?reporter if 
	?issue isIssue,?reporter equals: [?issue reporter]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:22'!
isIssueReportedInVersionXM2

?issue isIssueReportedInVersion: ?version if 
	?issue isIssue,?version equals: [?issue versionReported]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:23'!
isIssueResolvedInVersionXM2

?issue isIssueResolvedInVersion: ?version if 
	?issue isIssue,?version equals: [?issue versionResolved],[?version notNil]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:25'!
isIssueSubmittedOnXM2

?issue isIssueSubmittedOn: ?date if 
	?issue isIssue,?date equals: [?issue whenSubmitted],[?date notNil]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:24'!
isIssueWithPriorityXM2

?issue isIssueWithPriority: ?priority if 
	?issue isIssue,?priority equals: [?issue priority]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:28'!
isIssueWithResolutionXM2

?issue isIssueWithResolution: ?resolution if 
	?issue isIssue,?resolution equals: [?issue resolution]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:25'!
isIssueWithSeverityXM2

?issue isIssueWithSeverity: ?severity if 
	?issue isIssue,?severity equals: [?issue severity]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:20'!
isIssueWithStatusXM2

?issue isIssueWithStatus: ?status if 
	?issue isIssue,?status equals: [?issue status]! !

!MantisLayer methodsFor: 'issues' stamp: 'AndyKellens 3/12/2012 17:21'!
isIssueWithSummaryXM2

?issue isIssueWithSummary: ?summary if 
	?issue isIssue,?summary equals: [?issue summary]! !

!MantisLayer methodsFor: 'projects' stamp: 'AndyKellens 3/12/2012 17:07'!
isProjectM1

-?project isProject if 
	[SoulMantisRepository current projects] contains: ?project.

+?project isProject if 
	[?project isKindOf:SoulMantisProject]! !

!MantisLayer methodsFor: 'projects' stamp: 'AndyKellens 3/12/2012 17:08'!
isProjectWithNameXM2

?project isProjectWithName: -?name if 
	?project isProject,?name equals: [?project name].

?project isProjectWithName: +?name if 
	?project equals: [SoulMantisRepository current projectWithName:?name],[?project notNil]! !
MantisLayer initialize!
